#jupyter lab
#python question02.py

from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np
import pylab as pl
import methodes as met



N=10
dt=0.02
T=0.4
xx,tt,v=met.eqc(N,dt,T)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,v,color='whitesmoke')
plt.show()
plt.close()

#plt.gca().set_aspect('equal')
plt.contour(xx,tt,v,levels=np.arange(0.,0.1,0.001),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()

uu=np.sin(np.pi*xx)*np.exp(-np.pi**2*tt)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,uu,color='whitesmoke')
plt.show()
plt.close()

#plt.gca().set_aspect('equal')
plt.contour(xx,tt,uu,levels=np.arange(0.,0.8,0.05),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()

    
xx,tt,err,v=met.eqc_(N,dt,T)
print('Erreur: ',err)

N=185 #100
xx,tt,err,v=met.eqc_(N,dt,T)
print('Erreur: ',err)

dt=0.01
xx,tt,err,v=met.eqc_(N,dt,T)
print('Erreur: ',err)

tabdt=np.array([0.02,0.01,0.005,0.002,0.001])
taberr=np.zeros(len(tabdt))
i=0
for dt in tabdt:
    xx,tt,err,v=met.eqc_(N,dt,T)
    taberr[i]=err
    i+=1
tabdt=np.log(tabdt)
taberr=np.log(taberr)
r=(taberr[1:]-taberr[:-1])/(tabdt[1:]-tabdt[:-1])
print('pente: ',r)


pl.plot(tabdt,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()


# Schema explicite-implicite

N=10
dt=0.02
T=0.4
xx,tt,err,v=met.eqc2(N,dt,T)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,v,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,uu,color='whitesmoke')
plt.show()
plt.close()

w=v-uu
ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,w,color='whitesmoke')
plt.show()
plt.close()

plt.gca().set_aspect('equal')
plt.contour(xx,tt,w,levels=np.arange(-1.5,1.5,0.1),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()


tabdt=np.array([0.02,0.01,0.005,0.002,0.001])
taberr=np.zeros(len(tabdt))
i=0
for dt in tabdt:
    xx,tt,err,v=met.eqc2(N,dt,T)
    taberr[i]=err
    i+=1
tabdt=np.log(tabdt)
taberr=np.log(taberr)
r=(taberr[1:]-taberr[:-1])/(tabdt[1:]-tabdt[:-1])
print('pente: ',r)


pl.plot(tabdt,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()


# Schema explicite

N=20
dt=0.02
T=0.4
xx,tt,err,v=met.eqc1(N,dt,T)
uu=np.sin(np.pi*xx)*np.exp(-np.pi**2*tt)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,v,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,uu,color='whitesmoke')
plt.show()
plt.close()

w=v-uu
ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,w,color='whitesmoke')
plt.show()
plt.close()

plt.gca().set_aspect('equal')
plt.contour(xx,tt,w,levels=np.arange(0.,2.0,0.05),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()


# Schema explicite

N=20
dt=0.02
T=0.4
xx,tt,err,v=met.eqc1(N,dt,T)
uu=np.sin(np.pi*xx)*np.exp(-np.pi**2*tt)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,v,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,uu,color='whitesmoke')
plt.show()
plt.close()

w=v-uu
ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,w,color='whitesmoke')
plt.show()
plt.close()

plt.gca().set_aspect('equal')
plt.contour(xx,tt,w,levels=np.arange(0.,2.0,0.05),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()


# Schema explicite retrograde

N=20
dt=0.02
T=0.4
xx,tt,err,v=met.eqc1b(N,dt,T)
uu=np.sin(np.pi*xx)*np.exp(-np.pi**2*tt)

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,v,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,uu,color='whitesmoke')
plt.show()
plt.close()

w=v-uu
ax=plt.axes(projection='3d')
ax.plot_surface(xx,tt,w,color='whitesmoke')
plt.show()
plt.close()

plt.gca().set_aspect('equal')
plt.contour(xx,tt,w,levels=np.arange(0.,2.0,0.05),colors=('k'),linestyles='solid',linewidths=0.5)
plt.show()





