/// methodes.sci: ///////
// exec methodes.sci /////////


function [x,u]=laplace(f,c,N)

h=1/(N+1);
h2=h*h;
x=0:h:1;
x=x';
xx=x(2:$-1);
A=eye(N,N)-diag(ones(1,N-1),-1);
A=A+A'+h2*diag(c(xx));


u=A\f(xx);
u=h2*u;


endfunction




function [x,u]=laplaceb(f,c,N)

h=1/(N+1);
h2=h*h;
x=0:h:1;
x=x';
xx=x(2:$);
A=eye(N+1,N+1)-diag(ones(1,N),-1);
A=A+A';
A=A+h2*diag(c(xx));
A(N+1,N+1)=1;
A(N+1,N)=-1;
//A(N,N+1)=0;
//A(N,N)=A(N,N)-1;
fxx=f(xx);
fxx($)=0;
u=A\f(xx);
u=h2*u;


endfunction


function [x,u]=laplacec(f,alpha,N)

h=1/(N+1);
h2=h*h;
x=0:h:1;
x=x';
xx=x(2:$-1);
B=eye(N,N)-diag(ones(1,N-1),-1);
A=B+B'-alpha*h*B;
u=A\f(xx);
u=h2*u;


endfunction


function [x,y,uh,ue,err,iter]=diffini(n)

h=1/(n+1);
h2=h*h;
[x,y]=meshgrid(0:h:1);
d=4+2*h2*%pi*%pi*ones(x+y);//4+h2*c(x,y);
fh(1:n+2,1:n+2)=h2*f(x,y);
uh=zeros(n+2,n+2);
aux=h*(0:n+1);

uh(:,1)=u_ex(aux',0);
uh(:,n+2)=u_ex(aux',1);
uh(1,:)=u_ex(0,aux);
uh(n+2,:)=u_ex(1,aux);

maxiter=100*n;
precis=1e-10;
iter=0;
err=1;
er=zeros(n+2,n+2);
v=uh;

while (err>precis)&(iter<maxiter)
iter=iter+1;
v(2:n+1,2:n+1)=(fh(2:n+1,2:n+1)+uh(1:n,2:n+1)...
+uh(3:n+2,2:n+1)+uh(2:n+1,1:n)...
+uh(2:n+1,3:n+2))./d(2:n+1,2:n+1);
er=abs(uh-v);
uh=v;
iter=maxiter-iter;
ue=u_ex(x,y);
err=max(er);
end


endfunction


function [x,t,v]=eqc(N,dt,T)
// Schéma implicite
h=1/(N+1); 
r=dt/h/h;
x=0:h:1;
t=0:dt:T;
v(1:N+2,1)=uc(x,0)';
v(1,1:length(t))=0;
A=eye(N,N)-diag(ones(1,N-1),1);
A=A+A';
B=eye(N,N)+r*A;
for i=2:length(t)
v(2:N+1,i)=B\v(2:N+1,i-1);
end
//err=max(abs(v'-u));
endfunction


function [x,t,v,err]=eqc_(N,dt,T)
// Schéma implicite
h=1/(N+1); 
r=dt/h/h;
x=0:h:1;
t=0:dt:T;
v(1:N+2,1)=uc(x,0)';
v(1,1:length(t))=0;
A=eye(N,N)-diag(ones(1,N-1),1);
A=A+A';
B=eye(N,N)+r*A;
for i=2:length(t)
v(2:N+1,i)=B\v(2:N+1,i-1);
end
[xx,tt]=meshgrid(x,t);
uu=uc(xx,tt);
err=max(abs(v'-uu));
endfunction

function [x,t,v,err]=eqc1(N,dt,T)
// Schéma explicite
h=1/(N+1); 
r=dt/h/h;
x=0:h:1;
t=0:dt:T;
v(1:N+2,1)=uc(x,0)';
v(1,1:length(t))=0;
A=eye(N,N)-diag(ones(1,N-1),1);
A=A+A';
B=eye(N,N)-r*A;
for i=2:length(t)
v(2:N+1,i)=B*v(2:N+1,i-1);
end
[xx,tt]=meshgrid(x,t);
uu=uc(xx,tt);
err=max(abs(v'-uu));
endfunction

function [x,t,v,err]=eqc1b(N,dt,T)
// Schéma explicite rétrograde
h=1/(N+1); 
r=dt/h/h;
x=0:h:1;
t=0:dt:T;
v(1:N+2,1)=uc(x,0)';
v(1,1:length(t))=0;
A=eye(N,N)-diag(ones(1,N-1),1);
A=A+A';
B=eye(N,N)+r*A;
for i=2:length(t)
v(2:N+1,i)=B*v(2:N+1,i-1);
end
[xx,tt]=meshgrid(x,t);
uu=uc(xx,tt);
err=max(abs(v'-uu));
endfunction



function [x,t,v,err]=eqc2(N,dt,T)
//  Schéma explicite-implicite
h=1/(N+1); 
r=dt/h/h;
x=0:h:1;
t=0:dt:T;
v(1:N+2,1)=uc(x,0)';
v(1,1:length(t))=0;
A=eye(N,N)-diag(ones(1,N-1),1);
A=A+A';
B1=eye(N,N)-r*A;
B=eye(N,N)+r*A;
for i=2:length(t)
v(2:N+1,i)=B\(B1*v(2:N+1,i-1));
end
[xx,tt]=meshgrid(x,t);
uu=uc(xx,tt);
err=max(abs(v'-uu));
endfunction


